<?php
class Ameex_Insurance_Model_Observer extends Varien_Event_Observer
{	
	public function placeOrderAfter($observer)
	{
		$helper = Mage::helper("ameex_insurance");
		$order = $observer->getEvent()->getOrder();
		$billingAddress = $order->getBillingAddress();
		$streetAddress = $billingAddress->getStreet();
		$orderItems = $order->getAllVisibleItems();
		$orderItemWithCompanyId = array();
		$allottedCompanyId = $helper->getAllottedCompanyId();
		
		/********************
		*	Allocate Order Items to respective companies
		********************/
		
		foreach($orderItems as $orderItem) {
			$product = Mage::getModel("catalog/product")->load($orderItem->getProduct()->getId());
			$insuranceCompanyId = $product->getInsuranceCompany();
			if(!empty($insuranceCompanyId) && !(is_null($insuranceCompanyId)) && ($insuranceCompanyId != "") && ($insuranceCompanyId > 0)) {
				$orderItemWithCompanyId[$insuranceCompanyId][] = $orderItem;
			}
			else {
				$orderItemWithCompanyId[$allottedCompanyId][] = $orderItem;
			}
		}
		$helper->allocateInsuranceCompanies($orderItemWithCompanyId,$allottedCompanyId);
		$orderItemIdWithCompanyId = array();
		foreach($orderItemWithCompanyId as $companyId => $orderItems) {
			foreach($orderItems as $orderItem) {
				$orderItemIdWithCompanyId[$companyId][] = $orderItem->getId();
			}		
		}
		foreach($orderItems as $orderItem) {
			$insuranceCompanyId = "";
			foreach($orderItemIdWithCompanyId as $companyId => $orderItemIds) {
				if(in_array($orderItem->getId(),$orderItemIds)) {
					$insuranceCompanyId = $companyId;
					break;
				}						
			}
			
			/********************
			*	Activation entries for each quantity of each product
			********************/

			for ($i=0; $i<$orderItem->getQtyOrdered(); $i++) {
				$activationData = Mage::getModel("ameex_insurance/activationDetails");
				$activationData->setFirstName($billingAddress->getFirstname());
				$activationData->setLastName($billingAddress->getLastname());
				$activationData->setEmail($order->getCustomerEmail());
				$activationData->setPhone($billingAddress->getTelephone());
				$activationData->setAddress1($streetAddress[0]);
				$activationData->setAddress2($streetAddress[1]);
				$activationData->setCity($billingAddress->getCity());
				$activationData->setState($billingAddress->getRegion());
				$activationData->setCountry($billingAddress->getCountry());
				$activationData->setZipcode($billingAddress->getPostcode());
				$activationData->setCreatedAt(time());
				$activationData->setInsuranceCompanyId($insuranceCompanyId);
				$activationData->setActivationCode($serialCode);
				$activationData->setOrderItemId($orderItem->getId());
				$activationData->save();
			}

			/********************
			*	To Insurance Company
			********************/

			// $insuranceCompany = Mage::getModel("ameex_insurance/company")->load($insuranceCompanyId);
			// $vars["productName"] = $orderItem->getName();
			// $vars["date"] = date("d/m/Y", time());
			// $vars["customerName"] = $billingAddress->getName();
			// $vars["customerEmail"] = $order->getCustomerEmail();
			// $vars["customerAddress"] = $streetAddress[0] . ", " . $streetAddress[1] . ", " . $billingAddress->getCity() . ", " . $billingAddress->getRegion() . ", " . $billingAddress->getCountry() . " - " . $billingAddress->getPostcode();
			// $helper->sendEmail(6, $insuranceCompany->getEmail(), $insuranceCompany->getName(), $vars);
		}
	}
}