<?php
class Ameex_Insurance_Block_Adminhtml_Company_GridContainer_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
   public function __construct()
   {
       parent::__construct();
       $this->setId('company');
       $this->setDefaultSort('id');
       $this->setDefaultDir('ASC');
       $this->setUseAjax(true);
       $this->setSaveParametersInSession(true);
   }
   
   protected function _prepareCollection()
   {
      $collection = Mage::getModel('ameex_insurance/company')->getCollection();
      $this->setCollection($collection);
      return parent::_prepareCollection();
   }
    
   protected function _prepareColumns()
   {
		$this->addColumn('id', array(
                    'header' => Mage::helper('ameex_insurance')->__('Company ID'),
                    'index' => 'id',
               ));
		
		$this->addColumn('name', array(
                    'header' => Mage::helper('ameex_insurance')->__('Company Name'),
                    'index' => 'name',
               ));

		$this->addColumn('email', array(
                    'header' => Mage::helper('ameex_insurance')->__('E-mail'),
                    'index' => 'email',
               ));

    $this->addColumn('status', array(
                    'header' => Mage::helper('ameex_insurance')->__('Status'),
                    'index' => 'status',
                    'type' => 'options',
                    'options' => Mage::getModel('ameex_insurance/options')->getEnableDisable(),
               ));
       
		$this->addColumn('orders_per_cycle', array(
                    'header' => Mage::helper('ameex_insurance')->__('Orders Per Cycle'),
                    'index' => 'orders_per_cycle',
               ));
		
		$this->addExportType('*/*/exportCsv', Mage::helper('ameex_insurance')->__('CSV'));
       
        return parent::_prepareColumns();
    }

	public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current'=>true));
    }
    
    public function getRowUrl($row)
    {
        return $this->getUrl('*/*/edit', array('id' => $row->getId()));
    }
    
    protected function _prepareMassaction()
	{
		$this->setMassactionIdField('company_id');
		$this->getMassactionBlock()->setFormFieldName('company_id');

		$this->getMassactionBlock()->addItem('update', array(
			'label'		=> Mage::helper('ameex_insurance')->__('Update'),
			'url'  		=> $this->getUrl('*/update/index', array('' => '')),
		));
		 
		return $this;
	}
}
