<?php
class Ameex_Insurance_Block_Adminhtml_Reports_ClaimDetails_GridContainer_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
	public function __construct()
	{
		parent::__construct();
		$this->setId('claimDetails');
		$this->setUseAjax(true);		
		$this->setDefaultSort('id');
		$this->setDefaultDir('DESC');
		$this->setSaveParametersInSession(true);
	}

	protected function _prepareCollection()
	{
		$collection = Mage::getModel('ameex_insurance/claimDetails')->getCollection();
		$this->setCollection($collection);
		return parent::_prepareCollection();
	}
    
   protected function _prepareColumns()
   {
		$currencyCode = Mage::app()->getStore()->getCurrentCurrencyCode();
		
		$this->addColumn('id', array(
            'header' => Mage::helper('ameex_insurance')->__('ID'),
            'index' => 'id',
        ));
		
		$this->addColumn('fraud', array(
            'header' => Mage::helper('ameex_insurance')->__('Possible Fraud'),
            'index' => 'fraud',
        ));

		$this->addColumn('claimed_at', array(
            'header' => Mage::helper('ameex_insurance')->__('Claimed On'),
            'index' => 'claimed_at',
            'type' => 'datetime',
        ));

        $this->addColumn('damaged_at', array(
            'header' => Mage::helper('ameex_insurance')->__('Damaged On'),
            'index' => 'damaged_at',
            'type' => 'datetime',
        ));

		$this->addColumn('first_name', array(
            'header' => Mage::helper('ameex_insurance')->__('First Name'),
            'index' => 'first_name',
        ));

        $this->addColumn('last_name', array(
            'header' => Mage::helper('ameex_insurance')->__('Last Name'),
            'index' => 'last_name',
        ));
		
		$this->addColumn('email', array(
					'header' => Mage::helper('ameex_insurance')->__('E-mail'),
					'index' => 'email',
		));

		$this->addColumn('device_number', array(
					'header' => Mage::helper('ameex_insurance')->__('Device Number'),
					'index' => 'device_number',
		));

		// $this->addColumn('policy_number', array(
		// 			'header' => Mage::helper('ameex_insurance')->__('Policy Number'),
		// 			'index' => 'policy_number',
		// ));

		$this->addColumn('damage_type', array(
					'header' => Mage::helper('ameex_insurance')->__('Damage Type'),
					'index' => 'damage_type',
		));

		$this->addColumn('device_work', array(
					'header' => Mage::helper('ameex_insurance')->__('Device Work'),
					'index' => 'device_work',
		));

		$this->addColumn('amount_paid', array(
					'header' => Mage::helper('ameex_insurance')->__('Amount Paid'),
					'index' => 'amount_paid',
					'type'  => 'price',
                	'currency_code' => $currencyCode,
		));

		$this->addColumn('agree_additional_charge', array(
					'header' => Mage::helper('ameex_insurance')->__('Agree Additional Charge'),
					'index' => 'agree_additional_charge',
		));

		$this->addColumn('view_details',
			array(
				'header'    => Mage::helper('ameex_insurance')->__('Details'),
				'type'      => 'action',
				'getter'     => 'getId',
                    'actions'   => array(
                        array(
                            'caption' => Mage::helper('ameex_insurance')->__('View'),
                            'url'     => array('base'=>'*/*/view'),
                            'field'   => 'id'
                        )
                    ),
				'filter'    => false,
				'sortable'  => false,
				'is_system' => true,
		));

		$this->addExportType('*/*/exportCsv', Mage::helper('ameex_insurance')->__('CSV'));

		return parent::_prepareColumns();
    }

	public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current'=>true));
    }
    
    public function getRowUrl($row)
    {
        return $this->getUrl('*/*/view', array('id' => $row->getId()));
    }
}
