<?php
class Ameex_Insurance_ActivationController extends Mage_Core_Controller_Front_Action
{
	public function indexAction()
	{
		$data = $this->getRequest()->getPost();
		$codes = Mage::getModel("serialcodes/serialcodes")
						->getCollection()
						->addFieldToFilter("code", array("eq"=>$data["activation-code"]));
            
        if(count($codes) == 1) {

        	/********************
        	*	Activation code exists
        	********************/

            $activationData = Mage::getModel("ameex_insurance/activationDetails")->getCollection()->addFieldToFilter("activation_code",$data["activation-code"]);
            if (count($activationData) == 1) {

            	/********************
            	*	Online order
            	********************/
            	
            	$activation = $activationData->getFirstItem();
                if(($activation->getImei() != "") && ($activation->getActivatedAt() != "0000-00-00 00:00:00")) {

                	/********************
                	*	Already activated
                	********************/
                	
	                Mage::getSingleton("core/session")->addError("This code has been used already. Please check again.");
	                $this->_redirect('*/*/result');
                }
				else {

					/********************
					*	Activate now
					********************/

					if ($data["first-name"] != "") {
						$activation->setFirstName($data["first-name"]);
					}if ($data["last-name"] != "") {
						$activation->setLastName($data["last-name"]);
					}if ($data["email"] != "") {
						$activation->setEmail($data["email"]);
					}if ($data["home-phone"] != "") {
						$activation->setPhone($data["phone"]);
					}if ($data["address-1"] != "") {
						$activation->setAddress1($data["address-1"]);
					}if ($data["address-2"] != "") {
						$activation->setAddress2($data["address-2"]);
					}if ($data["city"] != "") {
						$activation->setCity($data["city"]);
					}if ($data["state"] != "") {
						$activation->setState($data["state"]);
					}if ($data["country"] != "") {
						$activation->setCountry($data["country"]);
					}if ($data["zip"] != "") {
						$activation->setZipcode($data["zip"]);
					}if ($data["imei"] != "") {
						$activation->setImei($data["imei"]);
					}if ($data["manufacturer"] != "") {
						$activation->setManufacturer($data["manufacturer"]);
					}if ($data["phone-model"] != "") {
						$activation->setPhoneModel($data["phone-model"]);
					}if ($data["cell-phone"] != "") {
						$activation->setCellPhone($data["cell-phone"]);
					}if ($data["activation-code"] != "") {
						$activation->setActivationCode($data["activation-code"]);
					}if ($data["carrier"] != "") {
						$activation->setCarrier($data["carrier"]);
					}

					$activation->setActivatedAt(time());
					$activation->save();

					/********************
					*	To customer
					********************/
					
					$customerEmail = $activation->getEmail();
					$customerName = $activation->getFirstName() . " " . $activation->getLastName();
					Mage::helper('ameex_insurance')->sendEmail(4, $customerEmail, $customerName);
					//mail($customerEmail, 'Thanks for activating', "Thanks for activating");

					/********************
					*	To Insurance Company
					********************/
					
					$insuranceCompany = Mage::getModel("ameex_insurance/company")->load($activation->getInsuranceCompanyId());
					$insuranceEmail = $insuranceCompany->getEmail();
					$insuranceName = $insuranceCompany->getName();
					Mage::helper('ameex_insurance')->sendEmail(5, $insuranceEmail, $insuranceName, $data["first-name"]);
					//mail($insuranceCompany->getEmail(), 'Customer activated his/her device', "Customer activated his/her device");

					/********************
					*	To admin
					********************/
					
					$adminEmail = Mage::getStoreConfig('trans_email/ident_general/email');
					//mail($adminEmail, 'Customer activated his/her device and the Insurance company notified.', "Customer activated his/her device and the Insurance company notified.");

					Mage::getSingleton("core/session")->addSuccess("Your ShieldX2 protection is activated. Thank you!");
        			$this->_redirect('*/*/result');
				}
            }
            else {
            	
            	/********************
            	*	Offline order
            	********************/

            	$newActivation = Mage::getModel("ameex_insurance/activationDetails");
            	if ($data["first-name"] != "") {
					$newActivation->setFirstName($data["first-name"]);
				}if ($data["last-name"] != "") {
					$newActivation->setLastName($data["last-name"]);
				}if ($data["email"] != "") {
					$newActivation->setEmail($data["email"]);
				}if ($data["home-phone"] != "") {
					$newActivation->setPhone($data["phone"]);
				}if ($data["address-1"] != "") {
					$newActivation->setAddress1($data["address-1"]);
				}if ($data["address-2"] != "") {
					$newActivation->setAddress2($data["address-2"]);
				}if ($data["city"] != "") {
					$newActivation->setCity($data["city"]);
				}if ($data["state"] != "") {
					$newActivation->setState($data["state"]);
				}if ($data["country"] != "") {
					$newActivation->setCountry($data["country"]);
				}if ($data["zip"] != "") {
					$newActivation->setZipcode($data["zip"]);
				}if ($data["imei"] != "") {
					$newActivation->setImei($data["imei"]);
				}if ($data["manufacturer"] != "") {
					$newActivation->setManufacturer($data["manufacturer"]);
				}if ($data["phone-model"] != "") {
					$newActivation->setPhoneModel($data["phone-model"]);
				}if ($data["cell-phone"] != "") {
					$newActivation->setCellPhone($data["cell-phone"]);
				}if ($data["activation-code"] != "") {
					$newActivation->setActivationCode($data["activation-code"]);
				}if ($data["carrier"] != "") {
					$newActivation->setCarrier($data["carrier"]);
				}

				$sku = $codes->getFirstItem()->getSku();
				$product = Mage::getModel('catalog/product');
				$product->load($product->getIdBySku($sku));
				$insuranceCompanyId = $product->getInsuranceCompany();
				$helper = Mage::helper("ameex_insurance");
				$allottedCompanyId = $helper->getAllottedCompanyId();
				if(!empty($insuranceCompanyId) && !(is_null($insuranceCompanyId)) && ($insuranceCompanyId != "") && ($insuranceCompanyId > 0)) {
					$orderItemWithCompanyId[$insuranceCompanyId][] = 0;
					$newActivation->setInsuranceCompanyId($insuranceCompanyId);
				}
				else {
					$orderItemWithCompanyId[$allottedCompanyId][] = 0;
					$newActivation->setInsuranceCompanyId($allottedCompanyId);
				}
				
				$helper->allocateInsuranceCompanies($orderItemWithCompanyId,$allottedCompanyId);

				$newActivation->setCreatedAt(time());
				$newActivation->setActivatedAt(time()+100);
				$newActivation->save();

				/********************
				*	To customer
				********************/
				
				$customerEmail = $newActivation->getEmail();
				$customerName = $newActivation->getFirstName() . " " . $newActivation->getLastName();
				Mage::helper('ameex_insurance')->sendEmail(4, $customerEmail, $customerName);
				//mail($customerEmail, 'Thanks for activating your offline order', "Thanks for activating your offline order");

				/********************
				*	To Insurance Company
				********************/
				
				$insuranceCompany = Mage::getModel("ameex_insurance/company")->load($newActivation->getInsuranceCompanyId());
				$insuranceEmail = $insuranceCompany->getEmail();
				$insuranceName = $insuranceCompany->getName();
				Mage::helper('ameex_insurance')->sendEmail(5, $insuranceEmail, $insuranceName, $data);
				//mail($insuranceCompany->getEmail(), 'One offline order has been activated', "One offline order has been activated");

				/********************
				*	To admin
				********************/
				
				$adminEmail = Mage::getStoreConfig('trans_email/ident_general/email');
				//mail($adminEmail, 'One offline order has been activated and the Insurance company notified.', "CustomerOne offline order has been activated and the Insurance company notified.");

				Mage::getSingleton("core/session")->addSuccess("Your ShieldX2 protection is activated. Thank you!");
        		$this->_redirect('*/*/result');
            }
        }
        else {

        	/********************
        	*	Activation code doesn't exists
        	********************/
        	
        	Mage::getSingleton("core/session")->addError("The Activation Code you've entered does not exist.");
        	$this->_redirect('*/*/result');
        }
	}

	public function resultAction()
	{
		$this->loadLayout();
		$this->renderLayout();		
	}

	public function searchOrderAction()
	{
		$this->loadLayout();
		$this->renderLayout();
	}

	public function enterImeiAction()
	{
		$data = $this->getRequest()->getParams();
		$order = Mage::getModel("sales/order")->load($data["order_id"],"increment_id");
		if ($order->getId()) {
			if ($data["email"] == $order->getCustomerEmail()) {
				foreach($order->getAllVisibleItems() as $orderItem) {
					
					/********************
					*	Check how many items are there without IMEI
					********************/

					$activationDetailsWithoutImei = Mage::getModel("ameex_insurance/activationDetails")->getCollection()->addFieldToFilter('order_item_id', $orderItem->getId())->addFieldToFilter('imei', array('null' => true));
					foreach ($activationDetailsWithoutImei as $activationDetailWithoutImei) {
						$data["orderItemsWithoutImei"][$activationDetailWithoutImei->getId()] = $orderItem->getName();
					}
				}
				if (count($data["orderItemsWithoutImei"]) <= 0) {
					Mage::getSingleton("core/session")->addError("All the products in this order already have IMEI.");
	        		$this->_redirect('*/*/searchOrder');
	        		return "";
				}
				$this->loadLayout();
				$this->getLayout()->getBlock('get_imei')->setOrderItems($data["orderItemsWithoutImei"]);
				$this->renderLayout();
			} else {
				Mage::getSingleton("core/session")->addError("Please enter the correct e-mail address with which you have placed this order.");
	        	$this->_redirect('*/*/searchOrder');
			}
		} else {
			Mage::getSingleton("core/session")->addError("Please enter a valid Order #");
	        $this->_redirect('*/*/searchOrder');
		}		
	}

	public function saveImeiAction()
	{
		$data = $this->getRequest()->getParams();
		$count = 0;
		foreach ($data["orderItems"] as $activationDetailId => $imei) {
			if($imei != "") {
				
				/********************
				*	Insert the IMEI into Order Item's custom option
				********************/
				
				$activationDetail = Mage::getModel("ameex_insurance/activationDetails")->load($activationDetailId);
				$orderItemId = $activationDetail->getOrderItemId();

				$orderItem = Mage::getModel("sales/order_item")->load($orderItemId);
				$options = $orderItem->getProductOptions();
				$imeiAvailable = false;
				foreach($options['options'] as $key => $option) {
					if(strpos($option['label'],'IMEI') !== false) {
						$options['options'][$key]['value'] = ($option['value'] == "") ? $imei : ($option['value'].", ".$imei);
						$imeiAvailable = true;
						break;
					}
				}
				if (!isset($options['options']) || !$imeiAvailable) {
				    $options['options'] = array();
				    $options['options'][] = array(
					    'label' => 'IMEI',
					    'value' => $imei,
					);
				}
				$orderItem->setProductOptions($options);
				$orderItem->save();

				/********************
				*	Insert IMEI into the activation table
				********************/
				
				$activationDetail->setImei($imei)->setActivatedAt(time())->save();
				$count++;
			}
		}
		if ($count == 0) {
			Mage::getSingleton("core/session")->addError("No products activated");
		} else {
			Mage::getSingleton("core/session")->addSuccess("$count products were successfully activated.");
		}		
		$this->_redirect('*/*/result');
	}
}