<?php

class Limex_Advd_Block_Adminhtml_Widget_Order_Country
    extends Limex_Advd_Block_Adminhtml_Widget_Abstract_Chart
{
    public function getGroup()
    {
        return 'Sales';
    }

    public function getName()
    {
        return 'Sales By Country (Pie Chart)';
    }

    public function _prepareLayout()
    {
        $this->setTemplate('mst_advd/widget/chart/pie.phtml');

        return $this;
    }

    public function prepareOptions()
    {
        $this->_form->addField('interval', 'select', array(
                'name'   => 'interval',
                'label'  => Mage::helper('advr')->__('Period'),
                'value'  => $this->getParam('interval', Limex_Advr_Helper_Date::LAST_24H),
                'values' => Mage::helper('advr/date')->getIntervals(true, true),
            )
        );

        return $this;
    }

    protected function _getCollection()
    {
        if (!$this->hasData('collection')) {
            $interval = Mage::helper('advr/date')->getInterval($this->getParam('interval'), true);
            $filterData = new Varien_Object(array(
                'from'      => $interval->getFrom()->get(Varien_Date::DATETIME_INTERNAL_FORMAT),
                'to'        => $interval->getTo()->get(Varien_Date::DATETIME_INTERNAL_FORMAT),
                'store_ids' => $this->getParam('store_ids')
            ));

            $collection = Mage::getModel('advr/report_sales')
                ->setBaseTable('sales/order')
                ->selectColumns(array('country_id', 'sum_grand_total'))
                ->setFilterData($filterData)
                ->groupByColumn('country_id');

            $collection = array_reverse($collection->getItems());

            $this->setData('collection', $collection);
        }

        return $this->getData('collection');
    }

    public function getCategories()
    {
        $result = array();
        $collection = $this->_getCollection();

        foreach ($collection as $item) {
            $result[] = $item->getCountry();
        }

        return $result;
    }

    public function getSeries()
    {
        $series = array();

        $series[] = array('Country', 'Grand Total');

        foreach ($this->_getCollection() as $itm) {
            $series[] = array(
                Mage::app()->getLocale()->getCountryTranslation($itm->getCountryId()),
                floatval($itm->getSumGrandTotal()),
            );
        }

        return $series;
    }
}