<?php

class Limex_B2b_Adminhtml_B2bController extends Mage_Adminhtml_Controller_action
{

	public function customerAction(){
		$this->loadLayout();
		$this->getLayout()->getBlock('customer.grid')
		->setCustomers($this->getRequest()->getPost('customers', null));
		$this->renderLayout();
	}
	public function customergridAction(){
		$this->loadLayout();
		$this->getLayout()->getBlock('customer.grid')
		->setCustomers($this->getRequest()->getPost('customers', null));
		$this->renderLayout();
	}


	protected function _initAction() {
		$this->loadLayout()
		->_setActiveMenu('b2b/items')
		->_addBreadcrumb(Mage::helper('adminhtml')->__('Items Manager'), Mage::helper('adminhtml')->__('Item Manager'));

		return $this;
	}

	public function indexAction() {
		$this->_initAction()
		->renderLayout();
	}

	public function editAction() {
		$id     = $this->getRequest()->getParam('id');
		$model  = Mage::getModel('b2b/b2b')->load($id);

		if ($model->getId() || $id == 0) {
			$data = Mage::getSingleton('adminhtml/session')->getFormData(true);
			if (!empty($data)) {
				$model->setData($data);
			}

			Mage::register('b2b_data', $model);

			$this->loadLayout();
			$this->_setActiveMenu('b2b/items');

			$this->_addBreadcrumb(Mage::helper('adminhtml')->__('Item Manager'), Mage::helper('adminhtml')->__('Item Manager'));
			$this->_addBreadcrumb(Mage::helper('adminhtml')->__('Item News'), Mage::helper('adminhtml')->__('Item News'));

			$this->getLayout()->getBlock('head')->setCanLoadExtJs(true);

			$this->_addContent($this->getLayout()->createBlock('b2b/adminhtml_b2b_edit'))
			->_addLeft($this->getLayout()->createBlock('b2b/adminhtml_b2b_edit_tabs'));

			$this->renderLayout();
		} else {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('b2b')->__('Item does not exist'));
			$this->_redirect('*/*/');
		}
	}

	public function newAction() {
		$this->_forward('edit');
	}

	public function saveAction() {
		if ($data = $this->getRequest()->getPost()) {

		$data['created_date'] = date("Y-m-d H:i:s");
			$model = Mage::getModel('b2b/b2b');
			$model->setData($data)
			->setId($this->getRequest()->getParam('id'));

			try {

				$store = Mage::app()->getStore()->getStoreId();
				$send = $this->_sendStatusMail($data['email_id'], $data['password'], $store);

				$model->setEmailSend('Yes');
				Mage::getSingleton('adminhtml/session')->addSuccess(Mage::helper('b2b')->__('Email has been sent successfully to '.$data['email_id']));
				
/*
				// the message
$msg = "First line of text\nSecond line of text";

// use wordwrap() if lines are longer than 70 characters
$msg = wordwrap($msg,70);

// send email
mail("debendra.extrawork@gmail.com","My subject",$msg);
*/
				
			$to = $data['email_id'];
			$subject = "Your Password";

		$logoSrc = Mage::getStoreConfig('design/header/logo_src');
		$logoAlt = Mage::getStoreConfig('design/header/logo_alt');
		
		$packagename = Mage::getStoreConfig('design/package/name');
		$skinname = Mage::getStoreConfig('design/theme/skin');
		
		$imageurl = Mage::getDesign()->getSkinUrl('images/logo.gif');//Mage::getModel ('core/design_package')->getSkinUrl ($logoSrc);


		//$message = str_replace("imageurls",$imageurl,'<img src="imageurls" />');
			$message .= "
			
			<table>
			<tr>
			<th>Your Email id:</th>
			<td>".$data['email_id']."</td>
			</tr>
			<tr>
			<th>Your Password:</th>
			<td>".$data['password']."</td>
			</tr>
			</table>
			
			";

			// Always set content-type when sending HTML email
			$headers = "MIME-Version: 1.0" . "\r\n";
			$headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";

			// More headers
			$sender = Mage::getStoreConfig('trans_email/ident_general/email');
			$headers .= 'From: <'.$sender.'>' . "\r\n";

			mail($to,$subject,$message,$headers);

			
				$model->save();
				$b2b_id = $model->getId();
				if(isset($data['links'])){
					$customers = Mage::helper('adminhtml/js')->decodeGridSerializedInput($data['links']['customers']); //Save the array to your database

					$collection = Mage::getModel('b2b/grid')->getCollection();
					$collection->addFieldToFilter('b2b_id',$b2b_id);
					foreach($collection as $obj){
						$obj->delete();
					}
					foreach($customers as $key => $value){
						$model2 = Mage::getModel('b2b/grid');
						$model2->setB2bId($b2b_id);
						$model2->setCustomerId($key);
						$model2->setPosition($value['position']);
						$model2->save();
					}
				}

				Mage::getSingleton('adminhtml/session')->addSuccess(Mage::helper('b2b')->__('Item was successfully saved'));
				Mage::getSingleton('adminhtml/session')->setFormData(false);

				
				
				
				if ($this->getRequest()->getParam('back')) {
					$this->_redirect('*/*/edit', array('id' => $model->getId()));
					return;
				}
				$this->_redirect('*/*/');
				return;
			} catch (Exception $e) {
				Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
				Mage::getSingleton('adminhtml/session')->setFormData($data);
				$this->_redirect('*/*/edit', array('id' => $this->getRequest()->getParam('id')));
				return;
			}
		}
		Mage::getSingleton('adminhtml/session')->addError(Mage::helper('b2b')->__('Unable to find item to save'));
		$this->_redirect('*/*/');
	}
	
	
	private  function _sendStatusMail($customer_email, $customer_password, $store)
    {
        $emailTemplate  = Mage::getModel('core/email_template');
 
        $emailTemplate->loadDefault('b2b_tpl');
        $emailTemplate->setTemplateSubject('Your Password');
 
        // Get General email address (Admin->Configuration->General->Store Email Addresses)
        $salesData['email'] = Mage::getStoreConfig('trans_email/ident_general/email');
        $salesData['name'] = Mage::getStoreConfig('trans_email/ident_general/name'); 
        $emailTemplate->setSenderName($salesData['name']);
        $emailTemplate->setSenderEmail($salesData['email']);
 
        $emailTemplateVariables['customer_email'] = $customer_email;
		$emailTemplateVariables['password'] = $customer_password;
        $check = $emailTemplate->send($salesData['email'], $store, $emailTemplateVariables);
		
    }

	public function deleteAction() {
		if( $this->getRequest()->getParam('id') > 0 ) {
			try {
				$model = Mage::getModel('b2b/b2b');

				$model->setId($this->getRequest()->getParam('id'))
				->delete();

				Mage::getSingleton('adminhtml/session')->addSuccess(Mage::helper('adminhtml')->__('Item was successfully deleted'));
				$this->_redirect('*/*/');
			} catch (Exception $e) {
				Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
				$this->_redirect('*/*/edit', array('id' => $this->getRequest()->getParam('id')));
			}
		}
		$this->_redirect('*/*/');
	}

	public function massDeleteAction() {
		$b2bIds = $this->getRequest()->getParam('b2b');
		if(!is_array($b2bIds)) {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('adminhtml')->__('Please select item(s)'));
		} else {
			try {
				foreach ($b2bIds as $b2bId) {
					$b2b = Mage::getModel('b2b/b2b')->load($b2bId);
					$b2b->delete();
				}
				Mage::getSingleton('adminhtml/session')->addSuccess(
				Mage::helper('adminhtml')->__(
                        'Total of %d record(s) were successfully deleted', count($b2bIds)
				)
				);
			} catch (Exception $e) {
				Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
			}
		}
		$this->_redirect('*/*/index');
	}

}