<?php

class Magegiant_Affiliate_Model_Total_Invoice_Affiliate extends Mage_Sales_Model_Order_Invoice_Total_Abstract
{
    public function collect(Mage_Sales_Model_Order_Invoice $invoice){
        $baseDiscount = 0;
        $discount = 0;
        foreach ($invoice->getAllItems() as $item) {
            if ($item->getOrderItem()->isDummy()) {
                continue;
            }
            $orderItem = $item->getOrderItem();
            $orderItemDiscount = (float)$orderItem->getAffiliateAmount();
            $baseOrderItemDiscount = (float)$orderItem->getBaseAffiliateAmount();
            $orderItemQty = $orderItem->getQtyOrdered();
            if ($orderItemDiscount && $orderItemQty) {
                $discount -= $orderItemDiscount * $item->getQty() / $orderItemQty;
                $baseDiscount -= $baseOrderItemDiscount * $item->getQty() / $orderItemQty;
            }
        }
        if (!floatval($baseDiscount)) {
            $order = $invoice->getOrder();
            $baseDiscount = $order->getBaseAffiliateDiscount();
            $discount = $order->getAffiliateDiscount();
        }
        if (floatval($baseDiscount)){
            $baseDiscount = Mage::app()->getStore()->roundPrice($baseDiscount);
            $discount = Mage::app()->getStore()->roundPrice($discount);

            $invoice->setBaseAffiliateDiscount($baseDiscount);
            $invoice->setAffiliateDiscount($discount);

            $invoice->setBaseGrandTotal($invoice->getBaseGrandTotal() + $baseDiscount);
            $invoice->setGrandTotal($invoice->getGrandTotal() + $discount);
        }
        return $this;
    }
}