<?php

/* @var $installer Mage_Core_Model_Resource_Setup */
$installer = $this;

$installer->startSetup();

$installer->run("



ALTER TABLE {$this->getTable('affiliate_transaction')}
  ADD COLUMN `creditmemo_ids` varchar(255) NOT NULL default '';



DROP TABLE IF EXISTS {$this->getTable('affiliate_payment_verify')};
CREATE TABLE {$this->getTable('affiliate_payment_verify')}(
    `verify_id` int(10) unsigned NOT NULL auto_increment,
    `account_id` int(10) unsigned NOT NULL,
    `payment_method` varchar(63) NOT NULL default '',
    `field` varchar(100) NOT NULL default '',
    `info`  text NOT NULL default '',
    `verified`  tinyint(1) NOT NULL default '2',
    INDEX (`account_id`),
    FOREIGN KEY (`account_id`) REFERENCES {$this->getTable('affiliate_account')} (`account_id`) ON DELETE CASCADE ON UPDATE CASCADE,
    PRIMARY KEY (`verify_id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8;
    

ALTER TABLE {$this->getTable('affiliate_payment')}
    ADD COLUMN `is_reduced_balance` tinyint(1) NOT NULL default '0',
    ADD COLUMN `is_refund_balance` tinyint(1) NOT NULL default '0';

UPDATE {$this->getTable('affiliate_payment')} SET `is_reduced_balance` = '1' WHERE `status` = '3';

");

if (version_compare(Mage::getVersion(), '1.4.1.0', '>=')) {
    /*$installer->run("
    ALTER TABLE {$this->getTable('sales/order_item')}
        ADD COLUMN `affiliate_amount` decimal(12,4) default '0.0000',
        ADD COLUMN `base_affiliate_amount` decimal(12,4) default '0.0000',
        ADD COLUMN `affiliate_commission` decimal(12,4) default '0.0000';
    ALTER TABLE {$this->getTable('sales/invoice')}
      ADD COLUMN `affiliate_discount` decimal(12,4) default NULL,
      ADD COLUMN `base_affiliate_discount` decimal(12,4) default NULL;

    ALTER TABLE {$this->getTable('sales/creditmemo')}
      ADD COLUMN `affiliate_discount` decimal(12,4) default NULL,
      ADD COLUMN `base_affiliate_discount` decimal(12,4) default NULL;

    ");*/
    //    add columns to sales/order_item
    $installer->getConnection()->addColumn($this->getTable('sales/order_item'), 'affiliate_amount', 'decimal(12,4) default NULL');
    $installer->getConnection()->addColumn($this->getTable('sales/order_item'), 'base_affiliate_amount', 'decimal(12,4) default NULL');
    $installer->getConnection()->addColumn($this->getTable('sales/order_item'), 'affiliate_commission', 'decimal(12,4) default NULL');

    //    add columns to sales/invoice
    $installer->getConnection()->addColumn($this->getTable('sales/invoice'), 'affiliate_discount', 'decimal(12,4) default NULL');
    $installer->getConnection()->addColumn($this->getTable('sales/invoice'), 'base_affiliate_discount', 'decimal(12,4) default NULL');
    //    add columnss to sales/credimemo
    $installer->getConnection()->addColumn($this->getTable('sales/creditmemo'), 'affiliate_discount', 'decimal(12,4) default NULL');
    $installer->getConnection()->addColumn($this->getTable('sales/creditmemo'), 'base_affiliate_discount', 'decimal(12,4) default NULL');
} else {
    $setup = new Mage_Sales_Model_Mysql4_Setup('sales_setup');
    $setup->addAttribute('invoice', 'affiliate_discount', array('type' => 'decimal'));
    $setup->addAttribute('invoice', 'base_affiliate_discount', array('type' => 'decimal'));
    $setup->addAttribute('creditmemo', 'affiliate_discount', array('type' => 'decimal'));
    $setup->addAttribute('creditmemo', 'base_affiliate_discount', array('type' => 'decimal'));
}

/*transfer old data*/

if ($installer->tableExists($installer->getTable('affiliate_payment_verify'))) {
    /*transfer email paypal verified to verify table*/
    if ($installer->tableExists($installer->getTable('affiliate_payment_paypal'))) {
        $paypalSelect = $installer->getConnection()->select()->reset()
            ->from(array('p' => $installer->getTable('affiliate_payment')), array())
            ->where('p.status=3')
            ->joinInner(array('pp' => $installer->getTable('affiliate_payment_paypal')),
                'p.payment_id = pp.payment_id',
                array()
            )->columns(array(
                'account_id'     => 'p.account_id',
                'payment_method' => 'p.payment_method',
                'paypal_email'   => 'pp.email',
                'verified'       => 'ABS(1)'
            ))->group(array('p.account_id', 'p.payment_method', 'pp.email'));
        //Zend_Debug::dump($paypalSelect->__toString());die('1');
        $paypalSql = $paypalSelect->insertFromSelect($installer->getTable('affiliate_payment_verify'),
            array(
                'account_id', 'payment_method', 'field', 'verified'
            ),
            true
        );
        $installer->getConnection()->query($paypalSql);
    }
    /*end paypal*/

    /*transfer email moneybooker verified to verify table*/
    if ($installer->tableExists($installer->getTable('affiliatepayment_moneybooker'))) {
        $moneybookerSelect = $installer->getConnection()->select()->reset()
            ->from(array('p' => $installer->getTable('affiliate_payment')), array())
            ->where('p.status=3')
            ->joinInner(array('mb' => $installer->getTable('affiliatepayment_moneybooker')),
                'p.payment_id = mb.payment_id',
                array()
            )->columns(array(
                'account_id'     => 'p.account_id',
                'payment_method' => 'p.payment_method',
                'paypal_email'   => 'mb.email',
                'verified'       => 'ABS(1)'
            ))->group(array('p.account_id', 'p.payment_method', 'mb.email'));
        $moneybookerSql    = $moneybookerSelect->insertFromSelect($installer->getTable('affiliate_payment_verify'),
            array(
                'account_id', 'payment_method', 'field', 'verified'
            ),
            true
        );
        $installer->getConnection()->query($moneybookerSql);
    }
    /*end moneybooker*/

    /*transfer offline address verified to verify table*/
    if ($installer->tableExists($installer->getTable('affiliatepayment_offline'))) {
        $offlineSelect = $installer->getConnection()->select()->reset()
            ->from(array('p' => $installer->getTable('affiliate_payment')), array())
            ->where('p.status=3')
            ->joinInner(array('ol' => $installer->getTable('affiliatepayment_offline')),
                'p.payment_id = ol.payment_id',
                array()
            )->columns(array(
                'account_id'     => 'p.account_id',
                'payment_method' => 'p.payment_method',
                'address_id'     => 'ol.address_id',
                'verified'       => 'ABS(1)'
            ))->group(array('p.account_id', 'p.payment_method', 'ol.address_id'));
        $offlineSql    = $offlineSelect->insertFromSelect($installer->getTable('affiliate_payment_verify'),
            array(
                'account_id', 'payment_method', 'field', 'verified'
            ),
            true
        );
        $installer->getConnection()->query($offlineSql);
    }
    /*end offline*/

    /*transfer bank account verified to verify table*/
    if ($installer->tableExists($installer->getTable('affiliatepayment_bank'))) {
        $bankSelect = $installer->getConnection()->select()->reset()
            ->from(array('p' => $installer->getTable('affiliate_payment')), array())
            ->where('p.status=3')
            ->joinInner(array('ba' => $installer->getTable('affiliatepayment_bank')),
                'p.payment_id = ba.payment_id',
                array()
            )->columns(array(
                'account_id'     => 'p.account_id',
                'payment_method' => 'p.payment_method',
                'bankaccount_id' => 'ba.bankaccount_id',
                'verified'       => 'ABS(1)'
            ))->group(array('p.account_id', 'p.payment_method', 'ba.bankaccount_id'));
        $bankSql    = $bankSelect->insertFromSelect($installer->getTable('affiliate_payment_verify'),
            array(
                'account_id', 'payment_method', 'field', 'verified'
            ),
            true
        );
        $installer->getConnection()->query($bankSql);
    }
    /*end bank account*/
}


$installer->endSetup();
