<?php

class Magegiant_Affiliatereport_Block_Sales extends Mage_Adminhtml_Block_Dashboard_Bar
{
    /**
     * get Affiliate Statistic Helper
     *
     * @return Magegiant_Affiliatereport_Helper_Data
     */
    protected function _getStatisticHelper()
    {
        return Mage::helper('affiliatereport');
    }

    /**
     * get Statistic Reports Model
     *
     * @return Magegiant_Affiliatereport_Model_Reports
     */
    protected function _getReportsModel()
    {
        return Mage::getModel('affiliatereport/reports');
    }

    protected function _construct()
    {
        parent::_construct();
        $this->setTemplate('magegiant/affiliatereport/salebar.phtml');
    }

    protected function _prepareLayout()
    {
        $reports = $this->_getReportsModel();

        $filterStoreId  = array();
        $filterStoreIds = $filterStoreId;
        if ($storeId = $this->getRequest()->getParam('store')) {
            $filterStoreId  = array('store_id' => $storeId);
            $filterStoreIds = array('store_ids' => array('finset' => $storeId));
        }

        $reports->setCollection(Mage::getResourceModel('affiliate/transaction_collection'))
            ->setFilters($filterStoreId)
            ->addFilter('status', 1);
        $reportDataObject = $reports->resetSelectColumns()
            ->addCountColumn('total_transactions', 'transaction_id')
            ->addSumColumn('lifetime_sales_amount', 'total_amount')
            ->addSumColumn('total_commissions', 'commission')
            ->getDataObject();
        $this->addTotal($this->__('Lifetime Sales'), $reportDataObject->getLifetimeSalesAmount());
        $this->addTotal($this->__('Total Commissions'), $reportDataObject->getTotalCommissions());
        $this->addTotal($this->__('Total Transactions'), $reportDataObject->getTotalTransactions(), true);

        $this->addTotal($this->__('Total Affiliate Accounts')
            , Mage::getResourceModel('affiliate/account_collection')
                //->addFieldToFilter('status',1)
                ->getSize()
            , true
        );

        $reports->setCollection(Mage::getResourceModel('affiliate/payment_collection')->setLoadMethodInfo(false))
            ->setFilters($filterStoreIds)
            ->addFilter('status', 3);
        $reportDataObject = $reports->resetSelectColumns()
            ->addSumColumn('total_payout', 'amount')
            ->getDataObject();
        $this->addTotal($this->__('Total Payout'), $reportDataObject->getTotalPayout());

        $this->setEntryEditHead($this->__('General'))->setTableId('general');
        parent::_prepareLayout();
    }
}