<?php

require '../vendor/autoload.php';

use \SixBySix\RealtimeDespatch\Api\Credentials;
use SixBySix\RealtimeDespatch\Gateway\Factory\DefaultGatewayFactory;

$credentials = new Credentials();
$credentials->setEndpoint('https://getsquare.realtimedespatch.co.uk/web/');
$credentials->setChannel('magento');
$credentials->setOrganisation('myco');
$credentials->setUsername('magento');
$credentials->setPassword('getsquare');

$factory = new DefaultGatewayFactory();
$service = new SixBySix\RealtimeDespatch\Service\ProductService($factory->create($credentials));

try
{
    $newProduct = new SixBySix\RealtimeDespatch\Entity\Product();
    $newProduct->setExternalReference('UniCharge'.uniqid());
    $newProduct->setDescription('A new test description. '.uniqid());

    $duplicateProduct = new SixBySix\RealtimeDespatch\Entity\Product();
    $duplicateProduct->setExternalReference('UniCharge35');
    $duplicateProduct->setDescription('A new test description. '.uniqid());

    $failedProduct = new SixBySix\RealtimeDespatch\Entity\Product();
    $failedProduct->setExternalReference('UniCharge35'.uniqid());
    $failedProduct->setDescription(null);

    $products   = new SixBySix\RealtimeDespatch\Entity\ProductCollection();
    $products[] = $newProduct;
    $products[] = $duplicateProduct;
    $products[] = $failedProduct;

    $importReport = $service->importProducts($products);

    foreach ($importReport->getLines() as $line) {
        echo $line->getMessage()."\n";
    }
}
catch (Exception $ex)
{
    var_dump($ex->getMessage());
}