<?php

require '../vendor/autoload.php';

use \SixBySix\RealtimeDespatch\Api\Credentials;
use SixBySix\RealtimeDespatch\Gateway\Factory\DefaultGatewayFactory;

$credentials = new Credentials();
$credentials->setEndpoint('https://getsquare.realtimedespatch.co.uk/web/');
$credentials->setChannel('magento');
$credentials->setOrganisation('myco');
$credentials->setUsername('magento');
$credentials->setPassword('getsquare');

$factory = new DefaultGatewayFactory();
$service = new SixBySix\RealtimeDespatch\Service\InventoryService($factory->create($credentials));

try
{
    foreach ($service->retrieveInventory() as $product) {
        echo $product->getExternalReference()."\n";
    }
}
catch (Exception $ex)
{
    var_dump($ex->getMessage());
}